//-⥯
# include <stdio.h>
# include <conio.h>
# include <math.h>
# include <graphics.h>
# include <stdlib.h>
# include <dos.h>
# include <bios.h>
# include <alloc.h>
# define n 11

 void init(void)
 {
   int gdriver = DETECT, gmode, errorcode;
   initgraph(&gdriver, &gmode, "c:\\borlandc\\bgi");
   errorcode = graphresult();
   if (errorcode != grOk)
   {
     printf("Graphics error: %s\n", grapherrormsg(errorcode));
     printf("Press any key to halt:");
     getch();
     exit(1);
   }
 }

 void osi()
 {
   setcolor(BLUE);
   line(20,300,350,300);
   line(30,20,30,310);
   line(27,30,30,20);
   line(30,20,33,30);
   line(350,300,340,297);
   line(350,300,340,303);
   setcolor(WHITE);
   outtextxy(75,347,"- Y AH.");
   outtextxy(75,367,"- Y");
   for(int i=1;i<14;i++)
   {
     line(30+20*i,30,30+20*i,305);
     line(25,300-20*i,295,300-20*i);
   }
   setcolor(LIGHTBLUE);
   line(220,20,220,310);
   outtextxy(20,305,"0");
   outtextxy(225,305,"0.95");
   outtextxy(20,30,"Y");
   outtextxy(340,305,"X");
   outtextxy(10,275,"20");
 }

 float func(float x)
 {
   return((-7*exp(x)/6)+(exp(7*x)/6)+2);
 }

 void diag(float kappa1,float kappa2,float mu1,float mu2,
	   float a,float b,float c,float *x,float *y)
 {
   float alfa[n-1],betta[n-1];
   alfa[0]=kappa1;
   betta[0]=mu1;
   for(int i=1;i<n-1;i++)
   {
     alfa[i]=-1*c/(alfa[i-1]*a+b);
     betta[i]=(x[i]-betta[i-1]*a)/(alfa[i-1]*a+b);
   }
   y[n-1]=(kappa2*betta[n-2]+mu2)/(1-kappa2*alfa[n-2]);
   for(i=n-2;i>=0;i--)
     y[i]=alfa[i]*y[i+1]+betta[i];
 }

 void main(void)
 {
   clrscr();
   int as=0,bf=1;
   int kappa1=0,kappa2=0,mu1=0,mu2=0;
   float *x,*y,a,b,c,*f,*y1,h=.1;
   x=(float*) calloc (n-1, sizeof(float));
   y=(float*) calloc (n-1, sizeof(float));
   f=(float*) calloc (n-1, sizeof(float));
   y1=(float*) calloc (n-1, sizeof(float));

   for(int i=0;i<=n;i++)
   {
     x[i]=as+i*h;
     y[i]=func(x[i]);
   }

   a=h/3;
   b=4*h/3;
   c=h/3;

   for(i=0;i<n-1;i++)
     f[i]=(y[i+2]-2*y[i+1]+y[i])/h;
   diag (kappa1,kappa2,mu1,mu2,a,b,c,f,y1);
   float *a1,*b1,*c1,*d1,s;

   a1=(float*) calloc (n-1, sizeof(float));
   b1=(float*) calloc (n-1, sizeof(float));
   c1=(float*) calloc (n, sizeof(float));
   d1=(float*) calloc (n-1, sizeof(float));

   c1[0]=0;
   c1[n-1]=0;
   for(i=1;i<n-1;i++)
     c1[i]=y1[i-1];

   for(i=0;i<n;i++)
     a1[i]=y[i];

   for(i=1;i<n;i++)
   {
     b1[i-1]=(y[i]-y[i-1])/h-h*(2*c1[i-1]+c1[i])/3;
     d1[i-1]=(c1[i]-c1[i-1])/(3*h);
   }
   printf("  X              Y e᪮e           Y ee\n");
   for(i=0;i<n-1;i++)
   {
     s=a1[i]+b1[i]*h/2+c1[i]*pow(h,2)/4+d1[i]*pow(h,3)/8;
     printf ("\n%5.2f             %8.4f         	     %8.4f\n",.05+h*i,func(.05+i*h),s);
   }

   textcolor(YELLOW+BLINK);
   cprintf("\n    த");
   getch();

   init();
   osi();

   setcolor(LIGHTRED);
   line(50,350,70,350);
   moveto(30,299);
   for(i=0;i<n-1;i++)
   {
     lineto((.05+i*h)*200+30,300-func(.05+i*h));
     delay(100);
   }

   setcolor(LIGHTGREEN);
   line(50,370,70,370);
   moveto(30,299);
   for(i=0;i<n-1;i++)
   {
     delay(100);
     s=a1[i]+b1[i]*h/2+c1[i]*h*h/4+d1[i]*h*h*h/8;
     lineto((.05+i*h)*200+30,300-s);
   }

   while(bioskey(1)==0)
   {
     setcolor(YELLOW);
     settextstyle(GOTHIC_FONT,HORIZ_DIR,1);
     outtextxy(50,400,"Press any key for quit");
     delay(400);
     setfillstyle(1,BLACK);
     bar(50,390,300,450);
     delay(400);
   }
   getch();
   free(x);
   free(y);
   free(f);
   free(y1);
   free(a1);
   free(b1);
   free(c1);
   free(d1);
   closegraph();
}